VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_draw_objects MOD "
   ClientHeight    =   3255
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4590
   LinkTopic       =   "Form1"
   ScaleHeight     =   3255
   ScaleWidth      =   4590
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picMyCanvas 
      AutoRedraw      =   -1  'True
      Height          =   2895
      Left            =   120
      ScaleHeight     =   2835
      ScaleWidth      =   4275
      TabIndex        =   0
      Top             =   240
      Width           =   4335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuObjects 
      Caption         =   "&Objects"
      Begin VB.Menu mnuObject 
         Caption         =   "&Rectangle"
         Index           =   0
      End
      Begin VB.Menu mnuObject 
         Caption         =   "&Circle"
         Index           =   1
      End
      Begin VB.Menu mnuObject 
         Caption         =   "&Line"
         Index           =   2
      End
   End
   Begin VB.Menu mnuAttributes 
      Caption         =   "&Attributes"
      Enabled         =   0   'False
      Begin VB.Menu mnuAttribute 
         Caption         =   "&Delete"
         Index           =   0
      End
      Begin VB.Menu mnuAttribute 
         Caption         =   "&Border"
         Index           =   1
         Begin VB.Menu mnuAttributesBorderColor 
            Caption         =   "&Color"
            Begin VB.Menu mnuBorderColor 
               Caption         =   "&Black"
               Index           =   0
            End
            Begin VB.Menu mnuBorderColor 
               Caption         =   "&White"
               Index           =   1
            End
            Begin VB.Menu mnuBorderColor 
               Caption         =   "&Red"
               Index           =   2
            End
            Begin VB.Menu mnuBorderColor 
               Caption         =   "&Green"
               Index           =   3
            End
            Begin VB.Menu mnuBorderColor 
               Caption         =   "B&lue"
               Index           =   4
            End
         End
         Begin VB.Menu mnuAttributesBorderThickness 
            Caption         =   "&Thickness"
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&1"
               Index           =   1
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&2"
               Index           =   2
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&3"
               Index           =   3
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&4"
               Index           =   4
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&5"
               Index           =   5
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&6"
               Index           =   6
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&7"
               Index           =   7
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&8"
               Index           =   8
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&9"
               Index           =   9
            End
            Begin VB.Menu mnuAttributesBorderThick 
               Caption         =   "&10"
               Index           =   10
            End
         End
      End
      Begin VB.Menu mnuAttribute 
         Caption         =   "&Color"
         Index           =   2
         Begin VB.Menu mnuColor 
            Caption         =   "&Black"
            Index           =   0
         End
         Begin VB.Menu mnuColor 
            Caption         =   "&White"
            Index           =   1
         End
         Begin VB.Menu mnuColor 
            Caption         =   "&Red"
            Index           =   2
         End
         Begin VB.Menu mnuColor 
            Caption         =   "&Green"
            Index           =   3
         End
         Begin VB.Menu mnuColor 
            Caption         =   "B&lue"
            Index           =   4
         End
         Begin VB.Menu mnuColor 
            Caption         =   "-"
            Index           =   5
         End
         Begin VB.Menu mnuColor 
            Caption         =   "&Transparent"
            Index           =   6
         End
      End
      Begin VB.Menu mnuAttribute 
         Caption         =   "&Position"
         Index           =   3
         Begin VB.Menu mnuPosition 
            Caption         =   "Top &Top"
            Index           =   0
            Shortcut        =   ^J
         End
         Begin VB.Menu mnuPosition 
            Caption         =   "To &Bottom"
            Index           =   1
            Shortcut        =   ^K
         End
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'MODIFICATION of  VBHelper's 'howto_draw_objects'
'MOD by Roger Gilchrist <rojagilkrist@hotmail.com>
Option Explicit
' Tells what we are trying to do.
' True when the mouse is down during draw.
Private m_Drawing             As Boolean
' All of the drawing objects.
Private m_DrawingObjects      As Collection
' The currently selected object.
Private m_SelectedObject      As Object

Private Sub CheckMenus()

  Dim ctl As Control

  ' Check the right menu items for the selected object.
  If m_SelectedObject Is Nothing Then
    Exit Sub
  End If
  ' Uncheck all menu items
  For Each ctl In Controls
    If TypeOf ctl Is Menu Then
      ctl.Checked = False
    End If
  Next ctl
  ' Check the right items for this object.
  ' Fore color.
  Select Case m_SelectedObject.ForeColor
   Case vbBlack
    mnuBorderColor(0).Checked = True
   Case vbWhite
    mnuBorderColor(1).Checked = True
   Case vbRed
    mnuBorderColor(2).Checked = True
   Case vbGreen
    mnuBorderColor(3).Checked = True
   Case vbBlue
    mnuBorderColor(4).Checked = True
  End Select
  ' Fill color.
  If m_SelectedObject.FillStyle = vbFSTransparent Then
    mnuColor(6).Checked = True
   Else
    Select Case m_SelectedObject.FillColor
     Case vbBlack
      mnuColor(0).Checked = True
     Case vbWhite
      mnuColor(1).Checked = True
     Case vbRed
      mnuColor(2).Checked = True
     Case vbGreen
      mnuColor(3).Checked = True
     Case vbBlue
      mnuColor(4).Checked = True
    End Select
  End If
  ' Border thickness.
  mnuAttributesBorderThick(m_SelectedObject.DrawWidth).Checked = True

End Sub

Private Sub Form_Load()

  Set m_DrawingObjects = New Collection

End Sub

Private Sub Form_Resize()

  picMyCanvas.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight

End Sub

Private Sub mnuAttribute_Click(Index As Integer)

  Select Case Index
   Case 0
    RemoveSelectedObject
  End Select
  CheckMenus

End Sub

Private Sub mnuAttributesBorderThick_Click(Index As Integer)

  m_SelectedObject.DrawWidth = Index
  ReDraw

End Sub

Private Sub mnuBorderColor_Click(Index As Integer)

  Select Case Index
   Case 0
    m_SelectedObject.ForeColor = vbBlack
   Case 1
    m_SelectedObject.ForeColor = vbWhite
   Case 2
    m_SelectedObject.ForeColor = vbRed
   Case 3
    m_SelectedObject.ForeColor = vbGreen
   Case 4
    m_SelectedObject.ForeColor = vbBlue
  End Select
  ReDraw

End Sub

Private Sub mnuColor_Click(Index As Integer)

  Select Case Index
   Case 0
    m_SelectedObject.FillColor = vbBlack
   Case 1
    m_SelectedObject.FillColor = vbWhite
   Case 2
    m_SelectedObject.FillColor = vbRed
   Case 3
    m_SelectedObject.FillColor = vbGreen
   Case 4
    m_SelectedObject.FillColor = vbBlue
    'Case 5' seperator member
    'Case 6 'Transparent is set in the 'If Then' structure below
  End Select
  If Index < 5 Then
    m_SelectedObject.FillStyle = vbFSSolid
   Else
    m_SelectedObject.FillStyle = vbFSTransparent
  End If
  ReDraw

End Sub

Private Sub mnuFileExit_Click()

  Unload Me

End Sub

Private Sub mnuObject_Click(Index As Integer)

  Set m_SelectedObject = New clsDraw_Object
  m_DrawingObjects.Add m_SelectedObject
  Set m_SelectedObject.picCanvas = picMyCanvas
  Select Case Index
   Case 0
    m_SelectedObject.ObjType = OTRectangle
   Case 1
    m_SelectedObject.ObjType = OTCircle
   Case 2
    m_SelectedObject.ObjType = OTLine
  End Select
  picMyCanvas.MousePointer = vbCrosshair

End Sub

Private Sub mnuPosition_Click(Index As Integer)

  RemoveSelectedObject
  Select Case Index
   Case 0
    ' Read the object at the top of the list.
    m_DrawingObjects.Add m_SelectedObject
   Case 1
    ' Read the object at the bottom of the list.
    If m_DrawingObjects.Count > 0 Then
      m_DrawingObjects.Add m_SelectedObject, , 1
     Else
      m_DrawingObjects.Add m_SelectedObject
    End If
  End Select
  ReDraw

End Sub

Private Function ObjectAt(ByVal X As Single, _
                          ByVal Y As Single) As Object

  Dim i As Integer

  ' Find the object at this position.
  ' See if an object is here. Look from top
  ' to bottom.
  For i = m_DrawingObjects.Count To 1 Step -1
    If m_DrawingObjects(i).IsAt(X, Y) Then
      Exit For
    End If
  Next i
  If i > 0 Then
    Set ObjectAt = m_DrawingObjects(i)
   Else
    Set ObjectAt = Nothing
  End If

End Function

Private Sub picMyCanvas_MouseDown(Button As Integer, _
                                  Shift As Integer, _
                                  X As Single, _
                                  Y As Single)

  ' See what we are doing.

  On Error Resume Next ' this deals with object having been deleted
  If m_SelectedObject.Selected Then
    'If m_SelectedObject Is Nothing Then
    ' Select the object at (X, Y).
    SelectObject ObjectAt(X, Y)
   Else
    ' If this is the left button,
    ' start drawing the new object.
    ' Set drawing parameters for drawing
    ' the new object.
    m_SelectedObject.InitDrawing X, Y
    m_Drawing = True
  End If
  On Error GoTo 0

End Sub

Private Sub picMyCanvas_MouseMove(Button As Integer, _
                                  Shift As Integer, _
                                  X As Single, _
                                  Y As Single)

  ' Continue drawing.

  If Not m_Drawing Then
    Exit Sub
  End If
  m_SelectedObject.WhileDrawing X, Y
  ' Erase the old object.

End Sub

Private Sub picMyCanvas_MouseUp(Button As Integer, _
                                Shift As Integer, _
                                X As Single, _
                                Y As Single)

  'Dim r As Single
  
  Dim Obj As Object

  ' Create the new object.
  If Not m_Drawing Then
    Exit Sub
  End If
  m_SelectedObject.EndDrawing X, Y
  ' Add the new object to the collection.
  For Each Obj In m_DrawingObjects
    If Obj Is m_SelectedObject Then
      GoTo already
    End If
  Next Obj
  m_DrawingObjects.Add m_SelectedObject
  Set m_SelectedObject.picCanvas = picMyCanvas
already:
  ' Stop drawing.
  m_Drawing = False
  picMyCanvas.MousePointer = vbDefault
  ' Select the new object.
  SelectObject m_SelectedObject
  ReDraw

End Sub

Private Sub ReDraw()

  Dim Obj As Object

  ' Redraw all objects.
  picMyCanvas.Cls
  For Each Obj In m_DrawingObjects
    Obj.Draw
  Next Obj

End Sub

Private Sub RemoveSelectedObject()

  Dim i As Integer

  ' Remove the selected object from the
  ' m_DrawingObjects collection.
  ' Find the selected object's current position.
  For i = 1 To m_DrawingObjects.Count
    If m_DrawingObjects(i) Is m_SelectedObject Then
      Exit For
    End If
  Next i
  ' Remove the object.
  m_DrawingObjects.Remove i
  ReDraw

End Sub

Private Sub SelectObject(Obj As Object)

  ' Deselect the previously selected object if any.
  ' Select the object (it may be Nothing).

  If Not m_SelectedObject Is Nothing Then
    m_SelectedObject.Selected = False
  End If
  ' Select the new object.
  Set m_SelectedObject = Obj
  If Not m_SelectedObject Is Nothing Then
    m_SelectedObject.Selected = True
  End If
  ' Enable or disable the Attributes accordingly.
  mnuAttributes.Enabled = (Not m_SelectedObject Is Nothing)
  ' Check the menus for the object's attributes.
  ReDraw

End Sub

':)Roja's VB Code Fixer V1.1.61 (25/11/2003 12:23:40 PM) 10 + 299 = 309 Lines Thanks Ulli for inspiration and lots of code.

